SystemOrganization addCategory: #'Xpf-Support-Quickstart'!
SystemOrganization addCategory: #'Xpf-Support-DemoData'!

Object subclass: #XpfDemoData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-DemoData'!

!XpfDemoData class methodsFor: 'setup' stamp: 'cs 3/20/2009 11:15'!
addDevelopers: anXpfProject
	
	XpfUser all do: [:developer | anXpfProject addDeveloper: developer].! !

!XpfDemoData class methodsFor: 'developers' stamp: 'cs 3/17/2009 15:21'!
christopher

	^ {'userName' -> 'cs'. 
		'login' -> 'christopher.schuster@student.hpi.uni-potsdam.de'. 
		'password' -> 'hodufi16'}! !

!XpfDemoData class methodsFor: 'developers' stamp: 'cs 3/17/2009 15:21'!
marcel

	^ {'userName' -> 'mt'. 
		'login' -> 'marcel.taeumel@student.hpi.uni-potsdam.de'. 
		'password' -> 'lilihu92'}! !

!XpfDemoData class methodsFor: 'developers' stamp: 'cs 3/17/2009 15:21'!
max

	^ {'userName' -> 'mfp'. 
		'login' -> 'max.plauth@student.hpi.uni-potsdam.de'. 
		'password' -> 'wuseli83'}! !

!XpfDemoData class methodsFor: 'developers' stamp: 'cs 3/17/2009 15:21'!
michael

	^ {'userName' -> 'mig'. 
		'login' -> 'michael.gruenewald@student.hpi.uni-potsdam.de'. 
		'password' -> 'pubawe51'}! !

!XpfDemoData class methodsFor: 'setup' stamp: 'cs 3/20/2009 11:14'!
setUp

	| xpforums |
	self setUpUsers.
	xpforums := XpfProject
		initialize;
		addNewProject: (Dictionary newFrom: {'title' -> 'XPForums'}).		
	self
		addDevelopers: xpforums;
		setUpAdminToolUserStory: xpforums;
		setUpHighlightUserStory: xpforums.! !

!XpfDemoData class methodsFor: 'userStories' stamp: 'cs 3/17/2009 16:00'!
setUpAdminToolUserStory: anXpfProject
	
	| adminTool |	
	adminTool := anXpfProject addNewUserStory: (Dictionary newFrom: {
		'title' -> 'Einfaches, administratives Werkzeug (UI und Serveranbindung) implementieren'.
		'priority' -> 'High'.
		'timeEstimated' -> 9.
		'timeActual' -> 21.5.
		'explanation' ->
'Ich moechte mit einem Werkzeug Nutzer und deren Projekte verwalten koennen.

    * Ich moechte einen neuen Nutzer erstellen/entfernen.
    * Ich moechte die Daten dieses Nutzers (Name, Login, Passwort usw.) auch mit diesem Tool modifizieren koennen.
    * Ich moechte ein neues Projekt anlegen koennen.
    * Ich moechte Nutzer zu Projekten hinzufuegen und entfernen koennen.
    * In dem Tool soll das Projekt (vorerst) nur minimal bearbeitbar sein (Name, Nutzer).
    * Ich kann mich nur als Admin anmelden.

Was ist ein Nutzer?

    * login (benutzername = e-mail-adresse)
    * passwort
    * name (nicht extra vorname, nachname - keine Probleme mit Mittelnamen)
    * Administrator heisst "admin", ist aber ein normaler Nutzer (mit Flag)'
	}).
	adminTool
		addNewTask: (Dictionary newFrom: self task73);
		addNewTask: (Dictionary newFrom: self task74);
		addNewTask: (Dictionary newFrom: self task75);
		addNewTask: (Dictionary newFrom: self task76);
		addNewTask: (Dictionary newFrom: self task77);
		addNewTask: (Dictionary newFrom: self task78);
		addNewTask: (Dictionary newFrom: self task79);
		addNewTask: (Dictionary newFrom: self task81);
		addNewTask: (Dictionary newFrom: self task82);
		addNewTask: (Dictionary newFrom: self task83);
		addNewTask: (Dictionary newFrom: self task84).! !

!XpfDemoData class methodsFor: 'userStories' stamp: 'cs 3/17/2009 16:00'!
setUpHighlightUserStory: anXpfProject
	
	| highlight |	
	highlight := anXpfProject addNewUserStory: (Dictionary newFrom: {
		'title' -> 'Farbliche Markierungen im Code erweitern'.
		'priority' -> 'Medium'.
		'timeEstimated' -> 12.
		'timeActual' -> 2.5.
		'explanation' ->
'Ich moehte die Moeglichkeit haben, den Code mit verschiedenen Farben zu markieren (gruen = guter Code, rot = schlechter Code, grau = unverstaendlicher Code). Hierbei spielt die Nutzbarkeit eine grosse Rolle.

Ich moechte aus einer kleinen Palette erst die Art der Markierung mit einem Mausklick auswaehlen und dann damit den entsprechenden Code markieren. Diese Palette sollte

Ich moechte ueber ein Tastenkuerzel die aktuelle Selektion des Codes in eine farbliche Markierung umwandeln.

Ich moechte ein Kontextmenue bei einer Selektion haben, welche mir verschiedene Arten von Markierung anbietet.
Acceptance Criteria

    * OB Package Browser oeffnen und eine Methode anzeigen.
    * Neuen "View" auswaehlen.
    * Aus der Palette "gut" auswaehlen und Code markieren.
    * Code markieren und [Cmd]+S (fuer schlecht == rot) druecken.
    * Code markieren und im Kontextmen "unverstaendlich" auswaehlen.
'}).
	highlight
		addNewTask: (Dictionary newFrom: self task48);
		addNewTask: (Dictionary newFrom: self task49);
		addNewTask: (Dictionary newFrom: self task50).! !

!XpfDemoData class methodsFor: 'setup' stamp: 'cs 3/17/2009 15:21'!
setUpUsers

	XpfUser
		initialize;
		addNewUser: (Dictionary newFrom: self christopher);
		addNewUser: (Dictionary newFrom: self marcel);
		addNewUser: (Dictionary newFrom: self max);
		addNewUser: (Dictionary newFrom: self michael);
		addNewUser: (Dictionary newFrom: self stefan);
		addNewUser: (Dictionary newFrom: self tobias).! !

!XpfDemoData class methodsFor: 'developers' stamp: 'cs 3/17/2009 15:22'!
stefan

	^ {'userName' -> 'SR'. 
		'login' -> 'stefanc.richter@student.hpi.uni-potsdam.de'. 
		'password' -> 'tifaha81'}! !

!XpfDemoData class methodsFor: 'tasks-highlight-code' stamp: 'cs 3/17/2009 15:54'!
task48

	^ {'title' -> 'Code-Markierung per Kontextmenue setzen'.
		'explanation' -> 'Im Kontextmenue einer Selektion sollen drei Eintraege fuer das Markieren (gruen, rot, grau) stehen - mit Symbol. Wenn man darauf klickt, wird der selektierte Code in der entsprechenden Farbe hervorgehoben.'.
		'timeEstimated' -> 2.
		'timeActual' -> 2.5}! !

!XpfDemoData class methodsFor: 'tasks-highlight-code' stamp: 'cs 3/17/2009 15:59'!
task49

	^ {'title' -> 'Zusaetzliche UI-Elemente im ''XPF-View'' anzeigen'.
		'explanation' -> 'Abhaengig vom View sollen neue UI-Elemente angezeigt werden.

Ziel: Zwischen OBPluggableTextMorphWithShout und OBEnhancementButtonBar steht eine Zeile Text mit den aktuellen Shortcuts fuer das Markieren.'.
		'timeEstimated' -> 6}! !

!XpfDemoData class methodsFor: 'tasks-highlight-code' stamp: 'cs 3/17/2009 15:59'!
task50

	^ {'title' -> 'Steuerelemente fuer Markierung im ''XPF-View'''.
		'explanation' ->
'Im View sollte es eine Art Palette geben, wo ich die Farbe auswaehlen kann. Dann markiere ich.

Entweder wird die Markierung sofort gesetzt, oder per Doppelklick oder sonstiger Bestaetigung. Dieser "Markiermodus" kann an- und abgewaehlt werden.'.
		'timeEstimated' -> 4}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:37'!
task73

	^ {'title' -> 'Verfuegbare Projekte anzeigen'.
		'explanation' -> ''.
		'timeEstimated' -> 0.5.
		'timeActual' -> 1}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:37'!
task74

	^ {'title' -> 'Verfuegbare Benutzer anzeigen'.
		'explanation' -> ''.
		'timeEstimated' -> 0.5.
		'timeActual' -> 2.5}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:37'!
task75

	^ {'title' -> 'Verfuegbare Projekte bearbeiten'.
		'explanation' -> ''.
		'timeEstimated' -> 1.
		'timeActual' -> 1}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:38'!
task76

	^ {'title' -> 'Verfuegbare Benutzer bearbeiten'.
		'explanation' -> ''.
		'timeEstimated' -> 1.
		'timeActual' -> 1}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:38'!
task77

	^ {'title' -> 'Neue Projekte anlegen'.
		'explanation' -> ''.
		'timeEstimated' -> 0.5.
		'timeActual' -> 1}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:39'!
task78

	^ {'title' -> 'Neue Benutzer anlegen'.
		'explanation' -> ''.
		'timeEstimated' -> 0.5.
		'timeActual' -> 1}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:39'!
task79

	^ {'title' -> 'Benutzer einem Projekt zuordnen/entfernen'.
		'explanation' -> ''.
		'timeEstimated' -> 2.
		'timeActual' -> 8}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:40'!
task81

	^ {'title' -> 'Administrator einfuehren'.
		'explanation' -> ''.
		'timeEstimated' -> 1.
		'timeActual' -> 0.5}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:40'!
task82

	^ {'title' -> 'Administrator muss sich im System authentifizieren koennen'.
		'explanation' -> ''.
		'timeEstimated' -> 1.
		'timeActual' -> 3}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:41'!
task83

	^ {'title' -> 'Projekte muessen geloescht werden koennen'.
		'explanation' -> ''.
		'timeEstimated' -> 0.5.
		'timeActual' -> 1.5}! !

!XpfDemoData class methodsFor: 'tasks-admin-tool' stamp: 'cs 3/17/2009 15:41'!
task84

	^ {'title' -> 'Benutzer muessen geloescht werden koennen'.
		'explanation' -> ''.
		'timeEstimated' -> 0.5.
		'timeActual' -> 1}! !

!XpfDemoData class methodsFor: 'developers' stamp: 'cs 3/17/2009 15:21'!
tobias

	^ {'userName' -> 'topa'. 
		'login' -> 'tobias.pape@student.hpi.uni-potsdam.de'. 
		'password' -> 'riwofe79'}! !

Object subclass: #XpfQuickstart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Quickstart'!

!XpfQuickstart class methodsFor: 'user interface' stamp: 'cs 3/18/2009 10:47'!
createButton: actionSel label: labelSel
	
	| btn |
	btn := UITheme current
		newButtonIn: World
		for: self
		getState: #state
		action: actionSel
		arguments: nil
		getEnabled: nil
		label: labelSel help: ''. 
	btn 
		vResizing: #spaceFill; 
		hResizing: #spaceFill.
	^ btn! !

!XpfQuickstart class methodsFor: 'user interface' stamp: 'mt 3/11/2009 14:45'!
createUpdateButton
	
	| btn |
	btn := PluggableButtonMorph on: XpfUpdateModel new getState: #state action: #update label: #info.
	btn 
		vResizing: #spaceFill; 
		hResizing: #spaceFill.
	^ btn! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'cs 3/20/2009 11:13'!
installDemoData

	| result |
	result := UITheme current
		questionWithoutCancelIn: World
		text: 'Do you want to perform the following actions?', String cr, 'Reset Local Database.', String cr, 'Add BP2008H1-Developers',String cr, 'Add XPForums Project'
		title: 'Install Demo Data?'.
	
	result ifTrue: [XpfDemoData setUp].! !

!XpfQuickstart class methodsFor: 'instance creation' stamp: 'cs 3/20/2009 11:08'!
open
	
	| align uBtn|
	align := AlignmentMorph newBounds: (50@50 corner: 700@80).
	uBtn := self createUpdateButton.
	align addMorph: uBtn.
	align addMorph: uBtn model.
	align addMorph: (self createButton: #installDemoData label: 'Install Demo Data').
	align addMorph: (self createButton: #resetLocalDatabase label: 'Reset Local Database').
	align addMorph: (self createButton: #stopHttpService label: 'Stop Server').
	align addMorph: (self createButton: #startHttpService label: 'Start Server').
	align addMorph: (self createButton: #openClientForServer label: 'Client').
	align addMorph: (self createButton: #startAdminTool label: 'AdminTool').
	align openInWorld.! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'mt 3/10/2009 17:02'!
openClientForServer
	XpfClient open.! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'mt 3/17/2009 10:28'!
resetLocalDatabase

	| result |
	result := UITheme current
		questionWithoutCancelIn: World
		text: 'Do you want to perform the following actions?', String cr, 'XpfUser initialize.', String cr, 'XpfProject initialize.'
		title: 'Reset local database?'.
	
	result ifTrue: [
		XpfUser initialize.
		XpfProject initialize].! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'mt 3/4/2009 09:51'!
startAdminTool
	XpfAdminTool open! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'mt 3/10/2009 17:00'!
startHttpService
	XpfService start.! !

!XpfQuickstart class methodsFor: 'model' stamp: 'mt 3/11/2009 14:58'!
state

	^ true! !

!XpfQuickstart class methodsFor: 'actions' stamp: 'mt 3/10/2009 17:01'!
stopHttpService
	XpfService stop.! !

Morph subclass: #XpfUpdateModel
	instanceVariableNames: 'info state'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Support-Quickstart'!

!XpfUpdateModel class methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2009 16:43'!
packages

	^ {
    'Xpf-CodeTalk'.
    'Rest-Server'. 
    'Rest-Client'.
    'Rest-Tests'.
    'Xpf-Server'.
    'Xpf-Client'.
    'Xpf-Support'} collect: [:n | MCPackage named: n]! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2009 17:38'!
addWorkingCopyFor: pkg

	| repoUrl pkgNames maxVer fileName repo |
	pkg workingCopy repositoryGroup repositories size = 1 ifTrue: [
		repoUrl := UITheme current
			textEntryIn: World
			text: 'Please enter url to an HTTP repository for:', String cr, pkg name
			title: 'New Package'
			entryText: 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/xpforums'.
    
		repoUrl ifNotNil: [
			repo := (MCHttpRepository location: repoUrl user: 'user' password: '').
			pkg workingCopy repositoryGroup addRepository: repo.
			
			repo password.
			"Checkout newest version of package."
			pkgNames := repo allVersionNames select: [:name | name startsWith: pkg name].
			maxVer := (pkgNames collect: [:name | (name findTokens: {$.}) last asNumber]) max.
			fileName := (pkgNames detect: [:v | v endsWith: maxVer asString]), '.mcz'.
			(repo loadVersionFromFileNamed: fileName) load]].! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/17/2009 10:04'!
check

	self hasUpdates
		ifTrue: [self state: true; info: 'Update now!!'; color: Color green]
		ifFalse: [self state: false; info: 'No updates available.'; color: Color gray].! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 17:20'!
databaseResetNeededFor: someVersions

	someVersions do: [:version | (version package name startsWith: 'Xpf-Server') ifTrue: [
			^ UITheme current questionWithoutCancelIn: World text: 'Do you want to reset the database?' title: 'Database structure changed']].
	^ false! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2009 17:21'!
hasUpdates

	self class packages do: [:pkg |
		pkg workingCopy repositoryGroup repositories size = 1
			ifTrue: [^ true].
		pkg workingCopy possiblyNewerVersions size > 0
			ifTrue: [^ true]].
	^ false! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 16:50'!
info

	^ info! !

!XpfUpdateModel methodsFor: 'accessing' stamp: 'mt 3/11/2009 16:51'!
info: anObject

	info := anObject.
	self changed: #info.! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/17/2009 10:02'!
initialize

	super initialize.
	self
		info: '...';
		height: 25;
		width: 25;
		state: false;
		check.
		
	[[true] whileTrue: [
		(Delay forDuration: (Duration minutes: 5)) wait.
		self check]] fork.! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2009 17:24'!
newPackages

	^ self class packages select: [:pkg |
		pkg workingCopy repositoryGroup repositories size = 1].! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 17:02'!
newVersions

	| result newerVersionNames newestVersionName maxVer fileName repo |
	result := OrderedCollection new.
	self class packages do: [:pkg |
		newerVersionNames := pkg workingCopy possiblyNewerVersions.
		newerVersionNames ifNotEmpty: [
			maxVer := (newerVersionNames collect: [:name | (name findTokens: {$.}) last asNumber]) max.
			newestVersionName := (newerVersionNames detect: [:v | v endsWith: maxVer asString]).
			repo := pkg workingCopy repositoryGroup repositories detect: [:r | r includesVersionNamed: newestVersionName].
			fileName := newestVersionName, '.mcz'.
			result add: (repo loadVersionFromFileNamed: fileName)]].
	^ result! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/11/2009 16:50'!
state

	^ state! !

!XpfUpdateModel methodsFor: 'accessing' stamp: 'mt 3/11/2009 16:51'!
state: anObject

	state := anObject.
	self changed: #state.! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/24/2009 17:42'!
update

	| nv nvString np npString |
	self state ifFalse: [^ self check].
	
	np := self newPackages.
	
	npString := (np collect: [:v | v name])
		inject: ''
		into: [:old :each | old, String cr, each ].

	np ifNotEmpty: [
		(UITheme current
			questionWithoutCancelIn: World
			text: 'Do you want to add the following packages?', String cr, npString
			title: 'New packages available') ifTrue: [
				np do: [:pkg | self addWorkingCopyFor: pkg]]].
	
	nv := self newVersions.
	
	nvString := (nv collect: [:v | v package name])
		inject: ''
		into: [:old :each | old, String cr, each ].
	
	nv ifNotEmpty: [
		(UITheme current
			questionWithoutCancelIn: World
			text: 'Do you want to update the following packages?', String cr, nvString
			title: 'Updates available') ifTrue: [
			nv do: [:version | version merge].
			self check]].
	
	(self databaseResetNeededFor: nv) ifTrue: [
		XpfUser initialize.
		XpfProject initialize].
	
	(self updaterUpdated: nv) ifTrue: [
		XpfQuickstart open].
! !

!XpfUpdateModel methodsFor: 'as yet unclassified' stamp: 'mt 3/17/2009 10:21'!
updaterUpdated: someVersions

	someVersions do: [:version | (version package name startsWith: 'Xpf-Support') ifTrue: [
			^ UITheme current questionWithoutCancelIn: World text: 'XpfQuickstart may have changed. Do you want to reopen the quickstart bar?' title: 'Xpf-Support package updated']].
	^ false! !
